custom_properties = property_set{
	document_owner = {
		properties = {
			["Master Level"] = number{
				min = 0,
				max = 1000,
				default = 734,
				midiCC = 7,
				property_tag = 0
			},
			["Master C Threshold"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 12,
				property_tag = 1
			},
			["Master C Ratio"] = selector{
				values = {"0","1","2"},
				default = "0",
				midiCC = 16,
				property_tag = 2
			},
			["Master C Attack"] = selector{
				values = {"0","1","2", "3", "4", "5"},
				default = 4,
				midiCC = 13,
				property_tag = 3
			},
			["Master C Release"] = selector{
				values = {"0","1","2", "3", "4"},
				default = 2,
				midiCC = 14,
				property_tag = 4
			},
			["Master C Make-Up Gain"] = number{
				min = 0,
				max = 127,
				default = 50,
				midiCC = 18,
				property_tag = 5
			},
			["Master Compressor On"] = boolean{
				default = true,
				midiCC = 17,
				property_tag = 6
			},

			["Channel 1 Mute"] = boolean{
				default = false,
				midiCC = 43,
				property_tag = 100
			},
			["Channel 1 Solo"] = boolean{
				default = false,
				midiCC = 44,
				property_tag = 101
			},
			["Channel 1 Level"] = number{
				min = 0,
				max = 1000,
				default = 734,
				midiCC = 45,
				property_tag = 102
			},
			["Channel 1 Comp On"] = boolean{
				default = false,
				midiCC = 46,
				property_tag = 103
			},
			["Channel 1 C Threshold"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 47,
				property_tag = 104
			},
			["Channel 1 C Release"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 48,
				property_tag = 105
			},
			["Channel 1 C Ratio"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 49,
				property_tag = 106
			},
			["Channel 1 C Peak"] = boolean{
				default = false,
				midiCC = 50,
				property_tag = 107
			},
			["Channel 1 C Fast Atk"] = boolean{
				default = false,
				midiCC = 51,
				property_tag = 108
			},
			["Channel 1 FX1 Send On"] = boolean{
				default = false,
				midiCC = 52,
				property_tag = 109
			},
			["Channel 1 FX1 Send Level"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 53,
				property_tag = 110
			},
			["Channel 1 FX2 Send On"] = boolean{
				default = false,
				midiCC = 54,
				property_tag = 111
			},
			["Channel 1 FX2 Send Level"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 55,
				property_tag = 112
			},

			["Channel 2 Mute"] = boolean{
				default = false,
				midiCC = 56,
				property_tag = 200
			},
			["Channel 2 Solo"] = boolean{
				default = false,
				midiCC = 57,
				property_tag = 201
			},
			["Channel 2 Level"] = number{
				min = 0,
				max = 1000,
				default = 734,
				midiCC = 58,
				property_tag = 202
			},
			["Channel 2 Comp On"] = boolean{
				default = false,
				midiCC = 59,
				property_tag = 203
			},
			["Channel 2 C Threshold"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 60,
				property_tag = 204
			},
			["Channel 2 C Release"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 61,
				property_tag = 205
			},
			["Channel 2 C Ratio"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 62,
				property_tag = 206
			},
			["Channel 2 C Peak"] = boolean{
				default = false,
				midiCC = 63,
				property_tag = 207
			},
			["Channel 2 C Fast Atk"] = boolean{
				default = false,
				midiCC = 64,
				property_tag = 208
			},
			["Channel 2 FX1 Send On"] = boolean{
				default = false,
				midiCC = 65,
				property_tag = 209
			},
			["Channel 2 FX1 Send Level"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 66,
				property_tag = 210
			},
			["Channel 2 FX2 Send On"] = boolean{
				default = false,
				midiCC = 67,
				property_tag = 211
			},
			["Channel 2 FX2 Send Level"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 68,
				property_tag = 212
			},

			["Channel 3 Mute"] = boolean{
				default = false,
				midiCC = 69,
				property_tag = 300
			},
			["Channel 3 Solo"] = boolean{
				default = false,
				midiCC = 70,
				property_tag = 301
			},
			["Channel 3 Level"] = number{
				min = 0,
				max = 1000,
				default = 734,
				midiCC = 71,
				property_tag = 302
			},
			["Channel 3 Comp On"] = boolean{
				default = false,
				midiCC = 72,
				property_tag = 303
			},
			["Channel 3 C Threshold"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 73,
				property_tag = 304
			},
			["Channel 3 C Release"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 74,
				property_tag = 305
			},
			["Channel 3 C Ratio"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 75,
				property_tag = 306
			},
			["Channel 3 C Peak"] = boolean{
				default = false,
				midiCC = 76,
				property_tag = 307
			},
			["Channel 3 C Fast Atk"] = boolean{
				default = false,
				midiCC = 77,
				property_tag = 308
			},
			["Channel 3 FX1 Send On"] = boolean{
				default = false,
				midiCC = 78,
				property_tag = 309
			},
			["Channel 3 FX1 Send Level"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 79,
				property_tag = 310
			},
			["Channel 3 FX2 Send On"] = boolean{
				default = false,
				midiCC = 80,
				property_tag = 311
			},
			["Channel 3 FX2 Send Level"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 81,
				property_tag = 312
			},
		}
	}
}

ui_category{
	ui_name = gui_text("UI Category: Master"),
	properties = {
		custom_properties["Master Level"],
		custom_properties["Master Compressor On"],
		custom_properties["Master C Threshold"],
		custom_properties["Master C Ratio"],
		custom_properties["Master C Attack"],
		custom_properties["Master C Release"],
		custom_properties["Master C Make-Up Gain"],
		custom_properties["Master C Ratio"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Channel 1 (Synth 1)"),
	properties = {
		custom_properties["Channel 1 Mute"],
		custom_properties["Channel 1 Solo"],
		custom_properties["Channel 1 Level"],
		custom_properties["Channel 1 Comp On"],
		custom_properties["Channel 1 C Threshold"],
		custom_properties["Channel 1 C Release"],
		custom_properties["Channel 1 C Ratio"],
		custom_properties["Channel 1 C Peak"],
		custom_properties["Channel 1 C Fast Atk"],
		custom_properties["Channel 1 FX1 Send On"],
		custom_properties["Channel 1 FX1 Send Level"],
		custom_properties["Channel 1 FX2 Send On"],
		custom_properties["Channel 1 FX2 Send Level"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Channel 2 (Synth 2)"),
	properties = {
		custom_properties["Channel 2 Mute"],
		custom_properties["Channel 2 Solo"],
		custom_properties["Channel 2 Level"],
		custom_properties["Channel 2 Comp On"],
		custom_properties["Channel 2 C Threshold"],
		custom_properties["Channel 2 C Release"],
		custom_properties["Channel 2 C Ratio"],
		custom_properties["Channel 2 C Peak"],
		custom_properties["Channel 2 C Fast Atk"],
		custom_properties["Channel 2 FX1 Send On"],
		custom_properties["Channel 2 FX1 Send Level"],
		custom_properties["Channel 2 FX2 Send On"],
		custom_properties["Channel 2 FX2 Send Level"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Channel 3 (Drums)"),
	properties = {
		custom_properties["Channel 3 Mute"],
		custom_properties["Channel 3 Solo"],
		custom_properties["Channel 3 Level"],
		custom_properties["Channel 3 Comp On"],
		custom_properties["Channel 3 C Threshold"],
		custom_properties["Channel 3 C Release"],
		custom_properties["Channel 3 C Ratio"],
		custom_properties["Channel 3 C Peak"],
		custom_properties["Channel 3 C Fast Atk"],
		custom_properties["Channel 3 FX1 Send On"],
		custom_properties["Channel 3 FX1 Send Level"],
		custom_properties["Channel 3 FX2 Send On"],
		custom_properties["Channel 3 FX2 Send Level"],
	}
}


audio_inputs = {
	["From FX1 Left Input"] = audio_input{},
	["From FX1 Right Input"] = audio_input{},
	["From FX2 Left Input"] = audio_input{},
	["From FX2 Right Input"] = audio_input{},

	["Channel 1 Left Input"] = audio_input{},
	["Channel 1 Right Input"] = audio_input{},
	["Channel 1 Sidechain Left Input"] = audio_input{},
	["Channel 1 Sidechain Right Input"] = audio_input{},

	["Channel 2 Left Input"] = audio_input{},
	["Channel 2 Right Input"] = audio_input{},
	["Channel 2 Sidechain Left Input"] = audio_input{},
	["Channel 2 Sidechain Right Input"] = audio_input{},

	["Channel 3 Left Input"] = audio_input{},
	["Channel 3 Right Input"] = audio_input{},
	["Channel 3 Sidechain Left Input"] = audio_input{},
	["Channel 3 Sidechain Right Input"] = audio_input{},
}

audio_outputs = {
	["Left Output"] = audio_output{},
	["Right Output"] = audio_output{},
	["To FX1 Left Output"] = audio_output{},
	["To FX1 Right Output"] = audio_output{},
	["To FX2 Left Output"] = audio_output{},
	["To FX2 Right Output"] = audio_output{},
}
