function listStrings(min, max) 
    local strings = {}
    for i=min,max do
        strings[i] = tostring(i)
    end
    return strings
end

custom_properties = property_set{
	document_owner = {
		properties = {
			["Master Level"] = number{
				min = 0,
				max = 127,
				default = 100,
				midiCC = 7
			},
			["Pitch Bend"] = number{
				min = -8192,
				max = 8191,
				default = 0,
				midiCC = 255
			},
			["Mod Wheel"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 1,
			},
			["Pitch Bend Range"] = number{
				min = 0,
				max = 24,
				default = 7,
				midiCC = 39
			},
			["Polyphony"] = number{
				min = 0,
				max = 32,
				default = 1,
				midiCC = 128
			},
			["Release Polyphony"] = number{
				min = 0,
				max = 32,
				default = 2,
				midiCC = 129
			},
			["Portamento Mode"] = selector{
				values = {"0","1","2"},
				default = 0,
				midiCC = 65
			},
            
			["Key Mode"] = selector{
				values = {"0","1","2"},
				default = 0,
				midiCC = 68
			},
			["Portamento"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 5
			},
			["Note Trigger MIDI"] = boolean{
				default = true,
				midiCC = 130
			},
            
			["Rotary 1"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 61
			},
            ["Rotary 2"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 62
			},
            ["Button 1"] = boolean{
				default = false,
				midiCC = 63
			},
            ["Button 2"] = boolean{
				default = false,
				midiCC = 67
			},
            
            
			["Osc 1 Type"] = selector{
				values = {"0","1","2","3","4","5","6"},
				default = 0,
				midiCC = 24
			},
			["Osc 1 Oct"] = number{
				min = 0,
				max = 9,
				default = 4,
				midiCC = 21
			},
			["Osc 1 Semi"] = number{
				min = 0,
				max = 12,
				default = 0,
				midiCC = 22
			},
			["Osc 1 Tune"] = number{
				min = -50,
				max = 50,
				default = 0,
				midiCC = 23
			},
            ["Osc 1 Kbd"] = number{
				min = 0,
				max = 127,
				default = 127,
				midiCC = 132
			},
            ["Osc 1 Analog Wave"] = selector{
				values = {"0","1","2","3"},
				default = 0,
				midiCC = 133
			},
            ["Osc 1 Mod"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 20
			},
            ["Osc 1 Wavetable Table"] = selector{
				values = listStrings(0, 31),
				default = 0,
				midiCC = 134
			},
            ["Osc 1 Wavetable Smooth X fade"] = boolean{
				default = true,
				midiCC = 135
			},
            ["Osc 1 Multi Wave"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 136
			},
            ["Osc 1 Multi Detuning Preset"] = selector{
				values = {"0","1","2","3","4","5","6","7"},
				default = 0,
				midiCC = 137
			},
            ["Osc 1 FM Pair Carrier"] = selector{
				values = listStrings(1, 32),
				default = 0,
				midiCC = 138
			},
            ["Osc 1 FM Pair Modulator"] = selector{
				values = listStrings(1, 32),
				default = 0,
				midiCC = 139
			},
            ["Osc 1 Noise Wave"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 140
			},
            ["Osc 1 Phase Modulation Wave 1"] = selector{
				values = {"0","1","2","3","4","5","6","7"},
				default = 0,
				midiCC = 141
			},
            ["Osc 1 Phase Modulation Wave 2"] = selector{
				values = {"0","1","2","3","4","5"},
				default = 0,
				midiCC = 142
			},
            ["Osc 1 AM From Osc 2"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 108
			},
            
            ["Osc 2 Type"] = selector{
				values = {"0","1","2","3","4","5","6"},
				default = 6,
				midiCC = 94
			},
			["Osc 2 Oct"] = number{
				min = 0,
				max = 9,
				default = 4,
				midiCC = 102
			},
			["Osc 2 Semi"] = number{
				min = 0,
				max = 12,
				default = 0,
				midiCC = 103
			},
			["Osc 2 Tune"] = number{
				min = -50,
				max = 50,
				default = 0,
				midiCC = 104
			},
            ["Osc 2 Kbd"] = number{
				min = 0,
				max = 127,
				default = 127,
				midiCC = 143
			},
            ["Osc 2 Analog Wave"] = selector{
				values = {"0","1","2","3"},
				default = 0,
				midiCC = 144
			},
            ["Osc 2 Mod"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 95
			},
            ["Osc 2 Wavetable Table"] = selector{
				values = listStrings(0, 31),
				default = 0,
				midiCC = 145
			},
            ["Osc 2 Wavetable Smooth X fade"] = boolean{
				default = true,
				midiCC = 146
			},
            ["Osc 2 Multi Wave"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 147
			},
            ["Osc 2 Multi Detuning Preset"] = selector{
				values = {"0","1","2","3","4","5","6","7"},
				default = 0,
				midiCC = 148
			},
            ["Osc 2 FM Pair Carrier"] = selector{
				values = listStrings(1, 32),
				default = 0,
				midiCC = 149
			},
            ["Osc 2 FM Pair Modulator"] = selector{
				values = listStrings(1, 32),
				default = 0,
				midiCC = 150
			},
            ["Osc 2 Noise Wave"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 151
			},
            ["Osc 2 Phase Modulation Wave 1"] = selector{
				values = {"0","1","2","3","4","5","6","7"},
				default = 0,
				midiCC = 152
			},
            ["Osc 2 Phase Modulation Wave 2"] = selector{
				values = {"0","1","2","3","4","5"},
				default = 0,
				midiCC = 153
			},
            ["Osc 2 Sync To Osc 1"] = boolean{
				default = false,
				midiCC = 106
			},
            ["Osc 2 Sync BW"] = number{
				min = 0,
				max = 127,
				default = 127,
				midiCC = 105
			},
            
            ["Osc 3 Type"] = selector{
				values = {"0","1","2","3","4","5","6"},
				default = 6,
				midiCC = 52
			},
			["Osc 3 Oct"] = number{
				min = 0,
				max = 9,
				default = 4,
				midiCC = 49
			},
			["Osc 3 Semi"] = number{
				min = 0,
				max = 12,
				default = 0,
				midiCC = 50
			},
			["Osc 3 Tune"] = number{
				min = -50,
				max = 50,
				default = 0,
				midiCC = 51
			},
            ["Osc 3 Kbd"] = number{
				min = 0,
				max = 127,
				default = 127,
				midiCC = 154
			},
            ["Osc 3 Analog Wave"] = selector{
				values = {"0","1","2","3"},
				default = 0,
				midiCC = 155
			},
            ["Osc 3 Mod"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 48
			},
            ["Osc 3 Wavetable Table"] = selector{
				values = listStrings(0, 31),
				default = 0,
				midiCC = 156
			},
            ["Osc 3 Wavetable Smooth X fade"] = boolean{
				default = true,
				midiCC = 157
			},
            ["Osc 3 Multi Wave"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 158
			},
            ["Osc 3 Multi Detuning Preset"] = selector{
				values = {"0","1","2","3","4","5","6","7"},
				default = 0,
				midiCC = 159
			},
            ["Osc 3 FM Pair Carrier"] = selector{
				values = listStrings(1, 32),
				default = 0,
				midiCC = 160
			},
            ["Osc 3 FM Pair Modulator"] = selector{
				values = listStrings(1, 32),
				default = 0,
				midiCC = 161
			},
            ["Osc 3 Noise Wave"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 162
			},
            ["Osc 3 Phase Modulation Wave 1"] = selector{
				values = {"0","1","2","3","4","5","6","7"},
				default = 0,
				midiCC = 163
			},
            ["Osc 3 Phase Modulation Wave 2"] = selector{
				values = {"0","1","2","3","4","5"},
				default = 0,
				midiCC = 164
			},
            ["Osc 3 Sync To Osc 1"] = boolean{
				default = false,
				midiCC = 54
			},
            ["Osc 3 Sync BW"] = number{
				min = 0,
				max = 127,
				default = 127,
				midiCC = 53
			},
            
            ["Osc 1 And 2 Level"] = number{
				min = 0,
				max = 127,
				default = 100,
				midiCC = 4
			},
            ["Osc 1 And 2 Balance"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 8
			},
            ["Osc 3 Level"] = number{
				min = 0,
				max = 127,
				default = 100,
				midiCC = 19
			},
            
            ["Filter 1 Type"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 76
			},
            ["Filter 1 Env Amount"] = number{
				min = 0,
				max = 127,
				default = 33,
				midiCC = 171
			},
            ["Filter 1 Env Invert"] = boolean{
				default = false,
				midiCC = 172
			},
            ["Filter 1 Velocity"] = number{
				min = 0,
				max = 127,
				default = 47,
				midiCC = 173
			},
            ["Filter 1 Kbd"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 77
			},
            ["Filter 1 Drive"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 174
			},
            ["Filter 1 Self Osc"] = boolean{
				default = true,
				midiCC = 175
			},
            ["Filter 1 Freq"] = number{
				min = 0,
				max = 127,
				default = 80,
				midiCC = 74
			},
            ["Filter 1 Res"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 71
			},
            ["Filter 1 State Var Notch"] = number{
				min = 0,
				max = 127,
				default = 66,
				midiCC = 176
			},
            ["Filter 1 State Var Mode"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 177
			},
            ["Filter 1 Ladder Slope"] = selector{
				values = {"0","1","2","3","4"},
				default = 1,
				midiCC = 178
			},
            ["Filter 1 Comb Preset"] = selector{
				values = {"0","1"},
				default = 1,
				midiCC = 179
			},
            ["Filter 1 Formant Gender"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 180
			},
            
            ["Filter 2 Type"] = selector{
				values = {"0","1","2","3","4"},
				default = 4,
				midiCC = 89
			},
            ["Filter 2 Env Amount"] = number{
				min = 0,
				max = 127,
				default = 33,
				midiCC = 181
			},
            ["Filter 2 Env Invert"] = boolean{
				default = false,
				midiCC = 182
			},
            ["Filter 2 Velocity"] = number{
				min = 0,
				max = 127,
				default = 47,
				midiCC = 183
			},
            ["Filter 2 Kbd"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 56
			},
            ["Filter 2 Drive"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 184
			},
            ["Filter 2 Self Osc"] = boolean{
				default = true,
				midiCC = 185
			},
            ["Filter 2 Freq"] = number{
				min = 0,
				max = 127,
				default = 80,
				midiCC = 79
			},
            ["Filter 2 Res"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 78
			},
            ["Filter 2 State Var Notch"] = number{
				min = 0,
				max = 127,
				default = 66,
				midiCC = 186
			},
            ["Filter 2 State Var Mode"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 187
			},
            ["Filter 2 Ladder Slope"] = selector{
				values = {"0","1","2","3","4"},
				default = 1,
				midiCC = 188
			},
            ["Filter 2 Comb Preset"] = selector{
				values = {"0","1"},
				default = 1,
				midiCC = 189
			},
            ["Filter 2 Formant Gender"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 190
			},
            
            ["Filter 3 Type"] = selector{
				values = {"0","1","2","3","4"},
				default = 4,
				midiCC = 57
			},
            ["Filter 3 Global Env Amount"] = number{
				min = 0,
				max = 127,
				default = 33,
				midiCC = 191
			},
            ["Filter 3 Global Env Invert"] = boolean{
				default = false,
				midiCC = 192
			},
            ["Filter 3 Velocity"] = number{
				min = 0,
				max = 127,
				default = 47,
				midiCC = 193
			},
            ["Filter 3 Kbd"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 60
			},
            ["Filter 3 Drive"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 194
			},
            ["Filter 3 Self Osc"] = boolean{
				default = true,
				midiCC = 195
			},
            ["Filter 3 Freq"] = number{
				min = 0,
				max = 127,
				default = 80,
				midiCC = 58
			},
            ["Filter 3 Res"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 59
			},
            ["Filter 3 State Var Notch"] = number{
				min = 0,
				max = 127,
				default = 66,
				midiCC = 196
			},
            ["Filter 3 State Var Mode"] = selector{
				values = {"0","1","2","3","4"},
				default = 0,
				midiCC = 197
			},
            ["Filter 3 Ladder Slope"] = selector{
				values = {"0","1","2","3","4"},
				default = 1,
				midiCC = 198
			},
            ["Filter 3 Comb Preset"] = selector{
				values = {"0","1"},
				default = 1,
				midiCC = 199
			},
            ["Filter 3 Formant Gender"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 200
			},
            
            ["Shaper Type"] = selector{
				values = {"0","1","2","3","4","5","6","7","8"},
				default = 0,
				midiCC = 84
			},
            ["Shaper Drive"] = number{
				min = 0,
				max = 127,
				default = 37,
				midiCC = 82
			},
            
            ["Mod Env Gate Trig On"] = boolean{
				default = true,
				midiCC = 201
			},
            ["Mod Env Delay"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 202
			},
            ["Mod Env Attack"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 87
			},
            ["Mod Env Decay"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 88
			},
            ["Mod Env Release"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 90
			},
            ["Mod Env Tempo Sync"] = boolean{
				default = false,
				midiCC = 203
			},
            ["Mod Env Loop"] = boolean{
				default = false,
				midiCC = 91
			},
            
            ["Filter Env Gate Trig On"] = boolean{
				default = true,
				midiCC = 204
			},
            ["Filter Env Attack"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 14
			},
            ["Filter Env Decay"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 15
			},
            ["Filter Env Sustain"] = number{
				min = 0,
				max = 127,
				default = 55,
				midiCC = 16
			},
            ["Filter Env Release"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 17
			},
            
            ["Amp Env Gate Trig On"] = boolean{
				default = true,
				midiCC = 205
			},
            ["Amp Env Attack"] = number{
				min = 0,
				max = 127,
				default = 5,
				midiCC = 73
			},
            ["Amp Env Decay"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 9
			},
            ["Amp Env Sustain"] = number{
				min = 0,
				max = 127,
				default = 55,
				midiCC = 66
			},
            ["Amp Env Release"] = number{
				min = 0,
				max = 127,
				default = 4,
				midiCC = 72
			},
            
            ["Global Env Gate Trig On"] = boolean{
				default = true,
				midiCC = 208
			},
            ["Global Env Delay"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 114
			},
            ["Global Env Attack"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 115
			},
            ["Global Env Hold"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 116
			},
            ["Global Env Decay"] = number{
				min = 0,
				max = 127,
				default = 40,
				midiCC = 117
			},
            ["Global Env Sustain"] = number{
				min = 0,
				max = 127,
				default = 55,
				midiCC = 118
			},
            ["Global Env Release"] = number{
				min = 0,
				max = 127,
				default = 40,
				midiCC = 119
			},
            ["Global Env Tempo Sync"] = boolean{
				default = false,
				midiCC = 209
			},
            ["Global Env Loop"] = boolean{
				default = false,
				midiCC = 92
			},
            
            ["Amplifier Gain"] = number{
				min = 0,
				max = 127,
				default = 100,
				midiCC = 206
			},
            ["Amplifier Velocity"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 207
			},
            ["Amplifier Pan"] = number{
				min = -64,
				max = 63,
				default = 0,
				midiCC = 10
			},
            
            ["LFO 1 Key Sync"] = boolean{
				default = false,
				midiCC = 30
			},
            ["LFO 1 Tempo Sync"] = boolean{
				default = false,
				midiCC = 31
			},
            ["LFO 1 Waveform"] = selector{
				values = listStrings(0, 17),
				default = 0,
				midiCC = 28
			},
            ["LFO 1 Rate"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 26
			},
            ["LFO 1 Delay"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 27
			},
            ["LFO 1 KbdFollow"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 29
			},
            
            ["LFO 2 Key Sync"] = boolean{
				default = false,
				midiCC = 113
			},
            ["LFO 2 Tempo Sync"] = boolean{
				default = false,
				midiCC = 109
			},
            ["LFO 2 Waveform"] = selector{
				values = listStrings(0, 17),
				default = 0,
				midiCC = 111
			},
            ["LFO 2 Rate"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 110
			},
            ["LFO 2 Delay"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 112
			},
            
            ["Chorus On"] = boolean{
				default = false,
				midiCC = 210
			},
            ["Chorus Rate"] = number{
				min = 0,
				max = 127,
				default = 40,
				midiCC = 211
			},
            ["Chorus Amt"] = number{
				min = 0,
				max = 127,
				default = 32,
				midiCC = 93
			},
            ["Chorus Delay"] = number{
				min = 0,
				max = 127,
				default = 64,
				midiCC = 55
			},
            ["Chorus Feedback"] = number{
				min = 0,
				max = 127,
				default = 0,
				midiCC = 83
			},
            ["Chorus Dry Wet"] = number{
				min = 0,
				max = 127,
				default = 60,
				midiCC = 13
			},
            
            ["Delay On"] = boolean{
				default = false,
				midiCC = 212
			},
            ["Delay Rate"] = number{
				min = 0,
				max = 127,
				default = 35,
				midiCC = 85
			},
            ["Delay Amt"] = number{
				min = 0,
				max = 127,
				default = 25,
				midiCC = 86
			},
            ["Delay Time"] = number{
				min = 0,
				max = 127,
				default = 48,
				midiCC = 18
			},
            ["Delay Feedback"] = number{
				min = 0,
				max = 127,
				default = 50,
				midiCC = 25
			},
            ["Delay Sync"] = boolean{
				default = false,
				midiCC = 213
			},
            ["Delay Dry Wet"] = number{
				min = 0,
				max = 127,
				default = 40,
				midiCC = 12
			},
            
            
            ["Osc 1 To Filter 1 Enable"] = boolean{
				default = true,
				midiCC = 165
			},
            ["Osc 2 To Filter 1 Enable"] = boolean{
				default = false,
				midiCC = 166
			},
            ["Osc 3 To Filter 1 Enable"] = boolean{
				default = false,
				midiCC = 167
			},
            ["Osc 1 To Filter 2 Enable"] = boolean{
				default = false,
				midiCC = 168
			},
            ["Osc 2 To Filter 2 Enable"] = boolean{
				default = false,
				midiCC = 169
			},
            ["Osc 3 To Filter 2 Enable"] = boolean{
				default = false,
				midiCC = 170
			},
            ["Shaper Output Dest"] = selector{
				values = {"0","1"},
				default = 1,
				midiCC = 80
			},
            ["Filter2ToAmplifier Enable"] = boolean{
				default = true,
				midiCC = 75
			},
            ["Shaper On"] = boolean{
				default = false,
				midiCC = 81
			},
            
            ["Mod 1 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 1 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 1 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 1 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 33
			},
            ["Mod 1 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 217
			},
            
            ["Mod 2 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 2 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 2 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 2 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 34
			},
            ["Mod 2 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 218
			},
            
            ["Mod 3 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 3 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 3 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 3 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 35
			},
            ["Mod 3 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 219
			},
            
            ["Mod 4 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 4 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 4 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 4 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 36
			},
            ["Mod 4 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 220
			},
            
            ["Mod 5 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 5 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 5 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 5 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 37
			},
            ["Mod 5 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 221
			},
            
            ["Mod 6 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 6 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 6 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 6 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 40
			},
            ["Mod 6 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 222
			},
            
            ["Mod 7 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 7 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 7 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 7 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 41
			},
            ["Mod 7 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 223
			},
            
            ["Mod 8 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 8 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 8 Dest 2"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 8 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 8 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 42
			},
            ["Mod 8 Dest 2 Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 224
			},
            ["Mod 8 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 225
			},
            
            ["Mod 9 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 9 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 9 Dest 2"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 9 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 9 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 43
			},
            ["Mod 9 Dest 2 Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 226
			},
            ["Mod 9 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 227
			},
            
            ["Mod 10 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 10 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 10 Dest 2"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 10 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 10 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 44
			},
            ["Mod 10 Dest 2 Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 228
			},
            ["Mod 10 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 229
			},
            
            ["Mod 11 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 11 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 11 Dest 2"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 11 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 11 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 45
			},
            ["Mod 11 Dest 2 Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 230
			},
            ["Mod 11 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 231
			},
            
            ["Mod 12 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 12 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 12 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 12 Scale 2"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 12 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 46
			},
            ["Mod 12 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 232
			},
            ["Mod 12 Scale 2 Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 233
			},
            
            ["Mod 13 Source"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 13 Dest"] = selector{
				values = listStrings(0, 82),
				default = 0,
			},
            ["Mod 13 Scale"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 13 Scale 2"] = selector{
				values = listStrings(0, 53),
				default = 0,
			},
            ["Mod 13 Dest Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 47
			},
            ["Mod 13 Scale Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 234
			},
            ["Mod 13 Scale 2 Amount"] = number{
				min = -100,
				max = 100,
				default = 0,
				midiCC = 235
			},
		}
	}
}

ui_category{
	ui_name = gui_text("UI Category: Performance"),
	properties = {
        custom_properties["Master Level"],
        custom_properties["Pitch Bend"],
        custom_properties["Mod Wheel"],
        custom_properties["Pitch Bend Range"],
        custom_properties["Polyphony"],
        custom_properties["Release Polyphony"],
        custom_properties["Portamento Mode"],
        custom_properties["Key Mode"],
        custom_properties["Portamento"],
        custom_properties["Note Trigger MIDI"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Modifiers"),
	properties = {
        custom_properties["Rotary 1"],
        custom_properties["Rotary 2"],
        custom_properties["Button 1"],
        custom_properties["Button 2"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Oscilator 1"),
	properties = {
        custom_properties["Osc 1 To Filter 1 Enable"],
        custom_properties["Osc 1 To Filter 2 Enable"],
        custom_properties["Osc 1 Type"],
        custom_properties["Osc 1 Oct"],
        custom_properties["Osc 1 Semi"],
        custom_properties["Osc 1 Tune"],
        custom_properties["Osc 1 Kbd"],
        custom_properties["Osc 1 Analog Wave"],
        custom_properties["Osc 1 Mod"],
        custom_properties["Osc 1 Wavetable Table"],
        custom_properties["Osc 1 Wavetable Smooth X fade"],
        custom_properties["Osc 1 Multi Wave"],
        custom_properties["Osc 1 Multi Detuning Preset"],
        custom_properties["Osc 1 FM Pair Carrier"],
        custom_properties["Osc 1 FM Pair Modulator"],
        custom_properties["Osc 1 Noise Wave"],
        custom_properties["Osc 1 Phase Modulation Wave 1"],
        custom_properties["Osc 1 Phase Modulation Wave 2"],
        custom_properties["Osc 1 AM From Osc 2"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Oscilator 2"),
	properties = {
        custom_properties["Osc 2 To Filter 1 Enable"],
        custom_properties["Osc 2 To Filter 2 Enable"],
        custom_properties["Osc 2 Type"],
        custom_properties["Osc 2 Oct"],
        custom_properties["Osc 2 Semi"],
        custom_properties["Osc 2 Tune"],
        custom_properties["Osc 2 Kbd"],
        custom_properties["Osc 2 Analog Wave"],
        custom_properties["Osc 2 Mod"],
        custom_properties["Osc 2 Wavetable Table"],
        custom_properties["Osc 2 Wavetable Smooth X fade"],
        custom_properties["Osc 2 Multi Wave"],
        custom_properties["Osc 2 Multi Detuning Preset"],
        custom_properties["Osc 2 FM Pair Carrier"],
        custom_properties["Osc 2 FM Pair Modulator"],
        custom_properties["Osc 2 Noise Wave"],
        custom_properties["Osc 2 Phase Modulation Wave 1"],
        custom_properties["Osc 2 Phase Modulation Wave 2"],
        custom_properties["Osc 2 Sync To Osc 1"],
        custom_properties["Osc 2 Sync BW"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Oscilator 3"),
	properties = {
        custom_properties["Osc 3 To Filter 1 Enable"],
        custom_properties["Osc 3 To Filter 2 Enable"],
         custom_properties["Osc 3 Type"],
         custom_properties["Osc 3 Oct"],
         custom_properties["Osc 3 Semi"],
         custom_properties["Osc 3 Tune"],
         custom_properties["Osc 3 Kbd"],
         custom_properties["Osc 3 Analog Wave"],
         custom_properties["Osc 3 Mod"],
         custom_properties["Osc 3 Wavetable Table"],
         custom_properties["Osc 3 Wavetable Smooth X fade"],
         custom_properties["Osc 3 Multi Wave"],
         custom_properties["Osc 3 Multi Detuning Preset"],
         custom_properties["Osc 3 FM Pair Carrier"],
         custom_properties["Osc 3 FM Pair Modulator"],
         custom_properties["Osc 3 Noise Wave"],
         custom_properties["Osc 3 Phase Modulation Wave 1"],
         custom_properties["Osc 3 Phase Modulation Wave 2"],
         custom_properties["Osc 3 Sync To Osc 1"],
         custom_properties["Osc 3 Sync BW"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Voice Mixer"),
	properties = {
        custom_properties["Osc 1 And 2 Level"],
        custom_properties["Osc 1 And 2 Balance"],
        custom_properties["Osc 3 Level"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Filter 1"),
	properties = {
        custom_properties["Filter 1 Type"],
        custom_properties["Filter 1 Env Amount"],
        custom_properties["Filter 1 Env Invert"],
        custom_properties["Filter 1 Velocity"],
        custom_properties["Filter 1 Kbd"],
        custom_properties["Filter 1 Drive"],
        custom_properties["Filter 1 Self Osc"],
        custom_properties["Filter 1 Freq"],
        custom_properties["Filter 1 Res"],
        custom_properties["Filter 1 State Var Notch"],
        custom_properties["Filter 1 State Var Mode"],
        custom_properties["Filter 1 Ladder Slope"],
        custom_properties["Filter 1 Comb Preset"],
        custom_properties["Filter 1 Formant Gender"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Filter 2"),
	properties = {
        custom_properties["Filter2ToAmplifier Enable"],
        custom_properties["Filter 2 Type"],
        custom_properties["Filter 2 Env Amount"],
        custom_properties["Filter 2 Env Invert"],
        custom_properties["Filter 2 Velocity"],
        custom_properties["Filter 2 Kbd"],
        custom_properties["Filter 2 Drive"],
        custom_properties["Filter 2 Self Osc"],
        custom_properties["Filter 2 Freq"],
        custom_properties["Filter 2 Res"],
        custom_properties["Filter 2 State Var Notch"],
        custom_properties["Filter 2 State Var Mode"],
        custom_properties["Filter 2 Ladder Slope"],
        custom_properties["Filter 2 Comb Preset"],
        custom_properties["Filter 2 Formant Gender"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Filter 3"),
	properties = {
        custom_properties["Filter 3 Type"],
        custom_properties["Filter 3 Global Env Amount"],
        custom_properties["Filter 3 Global Env Invert"],
        custom_properties["Filter 3 Velocity"],
        custom_properties["Filter 3 Kbd"],
        custom_properties["Filter 3 Drive"],
        custom_properties["Filter 3 Self Osc"],
        custom_properties["Filter 3 Freq"],
        custom_properties["Filter 3 Res"],
        custom_properties["Filter 3 State Var Notch"],
        custom_properties["Filter 3 State Var Mode"],
        custom_properties["Filter 3 Ladder Slope"],
        custom_properties["Filter 3 Comb Preset"],
        custom_properties["Filter 3 Formant Gender"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Shaper"),
	properties = {
        custom_properties["Shaper On"],
        custom_properties["Shaper Type"],
        custom_properties["Shaper Drive"],
        custom_properties["Shaper Output Dest"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Mod Envelope"),
	properties = {
        custom_properties["Mod Env Gate Trig On"],
        custom_properties["Mod Env Delay"],
        custom_properties["Mod Env Attack"],
        custom_properties["Mod Env Decay"],
        custom_properties["Mod Env Release"],
        custom_properties["Mod Env Tempo Sync"],
        custom_properties["Mod Env Loop"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Filter Envelope"),
	properties = {
        custom_properties["Filter Env Gate Trig On"],
        custom_properties["Filter Env Attack"],
        custom_properties["Filter Env Decay"],
        custom_properties["Filter Env Sustain"],
        custom_properties["Filter Env Release"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Amp Envelope"),
	properties = {
        custom_properties["Amp Env Gate Trig On"],
        custom_properties["Amp Env Attack"],
        custom_properties["Amp Env Decay"],
        custom_properties["Amp Env Sustain"],
        custom_properties["Amp Env Release"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Global Envelope"),
	properties = {
        custom_properties["Global Env Gate Trig On"],
        custom_properties["Global Env Delay"],
        custom_properties["Global Env Attack"],
        custom_properties["Global Env Hold"],
        custom_properties["Global Env Decay"],
        custom_properties["Global Env Sustain"],
        custom_properties["Global Env Release"],
        custom_properties["Global Env Tempo Sync"],
        custom_properties["Global Env Loop"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Amplifier"),
	properties = {
        custom_properties["Amplifier Gain"],
        custom_properties["Amplifier Velocity"],
        custom_properties["Amplifier Pan"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: LFO 1"),
	properties = {
        custom_properties["LFO 1 Key Sync"],
        custom_properties["LFO 1 Tempo Sync"],
        custom_properties["LFO 1 Waveform"],
        custom_properties["LFO 1 Rate"],
        custom_properties["LFO 1 Delay"],
        custom_properties["LFO 1 KbdFollow"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: LFO 2"),
	properties = {
        custom_properties["LFO 2 Key Sync"],
        custom_properties["LFO 2 Tempo Sync"],
        custom_properties["LFO 2 Waveform"],
        custom_properties["LFO 2 Rate"],
        custom_properties["LFO 2 Delay"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Chorus"),
	properties = {
        custom_properties["Chorus On"],
        custom_properties["Chorus Rate"],
        custom_properties["Chorus Amt"],
        custom_properties["Chorus Delay"],
        custom_properties["Chorus Feedback"],
        custom_properties["Chorus Dry Wet"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: Delay"),
	properties = {
        custom_properties["Delay On"],
        custom_properties["Delay Rate"],
        custom_properties["Delay Amt"],
        custom_properties["Delay Time"],
        custom_properties["Delay Feedback"],
        custom_properties["Delay Sync"],
        custom_properties["Delay Dry Wet"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 01"),
	properties = {
        custom_properties["Mod 1 Source"],
        custom_properties["Mod 1 Dest"],
        custom_properties["Mod 1 Dest Amount"],
        custom_properties["Mod 1 Scale"],
        custom_properties["Mod 1 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 02"),
	properties = {
        custom_properties["Mod 2 Source"],
        custom_properties["Mod 2 Dest"],
        custom_properties["Mod 2 Dest Amount"],
        custom_properties["Mod 2 Scale"],
        custom_properties["Mod 2 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 03"),
	properties = {
        custom_properties["Mod 3 Source"],
        custom_properties["Mod 3 Dest"],
        custom_properties["Mod 3 Dest Amount"],
        custom_properties["Mod 3 Scale"],
        custom_properties["Mod 3 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 04"),
	properties = {
        custom_properties["Mod 4 Source"],
        custom_properties["Mod 4 Dest"],
        custom_properties["Mod 4 Dest Amount"],
        custom_properties["Mod 4 Scale"],
        custom_properties["Mod 4 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 05"),
	properties = {
        custom_properties["Mod 5 Source"],
        custom_properties["Mod 5 Dest"],
        custom_properties["Mod 5 Dest Amount"],
        custom_properties["Mod 5 Scale"],
        custom_properties["Mod 5 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 06"),
	properties = {
        custom_properties["Mod 6 Source"],
        custom_properties["Mod 6 Dest"],
        custom_properties["Mod 6 Dest Amount"],
        custom_properties["Mod 6 Scale"],
        custom_properties["Mod 6 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 07"),
	properties = {
        custom_properties["Mod 7 Source"],
        custom_properties["Mod 7 Dest"],
        custom_properties["Mod 7 Dest Amount"],
        custom_properties["Mod 7 Scale"],
        custom_properties["Mod 7 Scale Amount"],
	}
}


ui_category{
	ui_name = gui_text("UI Category: xFree Routing 08"),
	properties = {
        custom_properties["Mod 8 Source"],
        custom_properties["Mod 8 Dest"],
        custom_properties["Mod 8 Dest Amount"],
        custom_properties["Mod 8 Dest 2"],
        custom_properties["Mod 8 Dest 2 Amount"],
        custom_properties["Mod 8 Scale"],
        custom_properties["Mod 8 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 09"),
	properties = {
        custom_properties["Mod 9 Source"],
        custom_properties["Mod 9 Dest"],
        custom_properties["Mod 9 Dest Amount"],
        custom_properties["Mod 9 Dest 2"],
        custom_properties["Mod 9 Dest 2 Amount"],
        custom_properties["Mod 9 Scale"],
        custom_properties["Mod 9 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 10"),
	properties = {
        custom_properties["Mod 10 Source"],
        custom_properties["Mod 10 Dest"],
        custom_properties["Mod 10 Dest Amount"],
        custom_properties["Mod 10 Dest 2"],
        custom_properties["Mod 10 Dest 2 Amount"],
        custom_properties["Mod 10 Scale"],
        custom_properties["Mod 10 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 11"),
	properties = {
        custom_properties["Mod 11 Source"],
        custom_properties["Mod 11 Dest"],
        custom_properties["Mod 11 Dest Amount"],
        custom_properties["Mod 11 Dest 2"],
        custom_properties["Mod 11 Dest 2 Amount"],
        custom_properties["Mod 11 Scale"],
        custom_properties["Mod 11 Scale Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 12"),
	properties = {
        custom_properties["Mod 12 Source"],
        custom_properties["Mod 12 Dest"],
        custom_properties["Mod 12 Dest Amount"],
        custom_properties["Mod 12 Scale"],
        custom_properties["Mod 12 Scale Amount"],
        custom_properties["Mod 12 Scale 2"],
        custom_properties["Mod 12 Scale 2 Amount"],
	}
}

ui_category{
	ui_name = gui_text("UI Category: xFree Routing 13"),
	properties = {
        custom_properties["Mod 13 Source"],
        custom_properties["Mod 13 Dest"],
        custom_properties["Mod 13 Dest Amount"],
        custom_properties["Mod 13 Scale"],
        custom_properties["Mod 13 Scale Amount"],
        custom_properties["Mod 13 Scale 2"],
        custom_properties["Mod 13 Scale 2 Amount"],
	}
}

--audio_inputs = {
--	["Audio Input 1"] = audio_input{},
--	["Audio Input 2"] = audio_input{},
--	["Audio Input 3"] = audio_input{},
--	["Audio Input 4"] = audio_input{},
--}

--cv_inputs = {
--	["Mod Wheel"] = cv_input{},
--	["Pitch Bend"] = cv_input{},
--	["Rotary 1"] = cv_input{},
--	["Rotary 2"] = cv_input{},
--	["Filter 1 Freq"] = cv_input{},
--	["Amp Level"] = cv_input{},
--}

audio_outputs = {
	["Left Output"] = audio_output{},
	["Right Output"] = audio_output{},
--	["Audio Output 3"] = audio_output{},
--	["Audio Output 4"] = audio_output{},
}

--cv_outputs = {
--	["Global Envelope"] = cv_output{},
--	["LFO 2"] = cv_output{},
--}

